######### SSO Configuration

map $mapping_id $saml_sp_entity_id {
  default "";

  {%- for mapping in rps_mappings %}
    {%- if mapping["saml_config"] is not none %}
  {{ mapping["id"] }} {{ mapping["source"] }};
    {%- endif %}
  {%- endfor %}
}

map $mapping_id $saml_sp_acs_url {
  default "";

  {%- for mapping in rps_mappings %}
    {%- if mapping["saml_config"] is not none %}
  {{ mapping["id"] }} {{ mapping["saml_config"]["acs_url"] }};
    {%- endif %}
  {%- endfor %}
}

map $mapping_id $saml_sp_request_binding {
  default 'HTTP-POST';
}

map $mapping_id $saml_sp_sign_authn {
  default "false";
}

map $mapping_id $saml_sp_signing_key {
  default "";
}

map $mapping_id $saml_sp_decryption_key {
  default "";
}

map $mapping_id $saml_sp_force_authn {
  default "false";

  {%- for mapping in rps_mappings %}
    {%- if mapping["saml_config"] is not none %}
  {{ mapping["id"] }} {{ mapping["saml_config"]["force_nauth"]|ternary("true", "false") }};
    {%- endif %}
  {%- endfor %}
}

map $mapping_id $saml_sp_nameid_format {
  default "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified";
}

map $mapping_id $saml_sp_relay_state {
  default "";
}

map $mapping_id $saml_sp_want_signed_response {
  default "false";
}

map $mapping_id $saml_sp_want_signed_assertion {
  default "false";
}

map $mapping_id $saml_sp_want_encrypted_assertion {
  default "false";
}

map $mapping_id $saml_idp_entity_id {
  default "ecas.ec.europa.eu";
}

map $mapping_id $saml_idp_sso_url {
  default "https://ecas.ec.europa.eu/cas";
}

map $mapping_id $saml_idp_verification_certificate {
  default "";
}

######### SLO Configuration

map $mapping_id $saml_sp_slo_url {
  default "";

  {%- for mapping in rps_mappings %}
    {%- if mapping["saml_config"] is not none %}
  {{ mapping["id"] }} {{ mapping["saml_config"]["logout_url"] }};
    {%- endif %}
  {%- endfor %}
}

map $mapping_id $saml_sp_slo_binding {
  default 'HTTP-POST';
}

map $mapping_id $saml_sp_sign_slo {
  default "false";
}

map $mapping_id $saml_idp_slo_url {
  default "https://ecas.ec.europa.eu/cas/logout";
}

map $mapping_id $saml_sp_want_signed_slo {
    default "false";
}

map $mapping_id $saml_logout_landing_page {
  default "/_logout"; # Built-in, simple logout page

  {%- for mapping in rps_mappings %}
    {%- if mapping["saml_config"] is not none %}
      {%- set url = mapping["source"] %}
      {%- if url is not regex("/$") %}
        {%- set url = url + "/" %}
      {%- endif %}
  {{ mapping["id"] }} {{ url }}saml/_logout;
    {%- endif %}
  {%- endfor %}
}

map $proto $saml_cookie_flags {
  http  "Path=/; SameSite=lax;"; # For HTTP/plaintext testing
  https "Path=/; SameSite=lax; HttpOnly; Secure;"; # Production recommendation
}

map $http_x_forwarded_port $redirect_base {
  ""      $proto://$host:$server_port;
  default $proto://$host:$http_x_forwarded_port;
}

map $http_x_forwarded_proto $proto {
  ""      $scheme;
  default $http_x_forwarded_proto;
}
